package week4;



import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;

import javax.swing.JFrame;

import com.jogamp.opengl.GL;
import com.jogamp.opengl.GL2;
import com.jogamp.opengl.GLAutoDrawable;
import com.jogamp.opengl.GLCapabilities;
import com.jogamp.opengl.GLEventListener;
import com.jogamp.opengl.GLProfile;
import com.jogamp.opengl.awt.GLJPanel;
import com.jogamp.opengl.util.FPSAnimator;

// A example illustrating using vertex normals by averaging face normals to get a smooth surface

public class Colors implements GLEventListener, KeyListener  {
	
	private boolean faceNormals = true;
  
    public static void main(String[] args) {
        // initialisation
        GLProfile glp = GLProfile.getDefault();
        GLCapabilities caps = new GLCapabilities(glp);
        
        // create a panel to draw on
        GLJPanel panel = new GLJPanel(caps);

        // put it in a JFrame
        final JFrame jframe = new JFrame("Smooth  shading");
        jframe.setSize(800, 800);
        jframe.add(panel);
        jframe.setVisible(true);
       
        jframe.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        Colors n = new Colors();
        panel.addGLEventListener(n);
        panel.addKeyListener(n);
        panel.setFocusable(true);   
        
        
        // NEW: add an animator to create display events at 60 FPS
        FPSAnimator animator = new FPSAnimator(60);
        animator.add(panel);
        animator.start();
    }
    
    /* 
     * Some maths utility functions
     * 
     */

    
    @Override
    public void display(GLAutoDrawable drawable) {
    	GL2 gl = drawable.getGL().getGL2();


    	gl.glMatrixMode(GL2.GL_MODELVIEW);
    	gl.glLoadIdentity();

    	//You can use glu look at or normal transformations
    	//to position the camera.
    	
    	
    	//Forgetting to clear the depth buffer can cause problems 
    	//such as empty black screens.
    	gl.glClear(GL.GL_COLOR_BUFFER_BIT | GL2.GL_DEPTH_BUFFER_BIT);
    	gl.glColor4d(1,1,1,1);
    
    
    	gl.glBegin(GL2.GL_QUADS);{
    		//6 points in space
    		double p0[] = {0.2,0,-2.3};
    		double p1[] = {0.2,1,-2.3};
    		double p2[] = {0,1,-2};
    		double p3[] = {0,0,-2};
    		double p4[] = {-0.2,1,-2};
    		double p5[] = {-0.2,0,-2}; 
    
    	    //Quad 1
    		gl.glColor3f(1, 0, 0);
    		gl.glVertex3dv(p0,0);
    		gl.glVertex3dv(p1,0); 
    		//gl.glColor3f(1, 1, 0);
    		gl.glVertex3dv(p2,0);
    		gl.glVertex3dv(p3,0);
    		
    		//Quad 2
    		gl.glColor3f(0, 1, 0);	
    		gl.glVertex3dv(p3,0);
    		gl.glVertex3dv(p2,0);  
    		//gl.glColor3f(0, 1, 0);
    		gl.glVertex3dv(p4,0);
    		gl.glVertex3dv(p5,0);
    		

    	}gl.glEnd();
    	
    	gl.glPolygonMode(GL2.GL_FRONT_AND_BACK, GL2.GL_FILL);
    }

    @Override
    public void dispose(GLAutoDrawable drawable) {
    }

    @Override
    public void init(GLAutoDrawable drawable) {
    	GL2 gl = drawable.getGL().getGL2();
    	
    	//If you do not add this line
    	//opengl will draw things in the order you
    	//draw them in your program
    	gl.glEnable(GL2.GL_DEPTH_TEST);    	
    }

    @Override
    public void reshape(GLAutoDrawable drawable, int x, int y, int w, int h) {
    	 GL2 gl = drawable.getGL().getGL2();
         gl.glMatrixMode(GL2.GL_PROJECTION);
         gl.glLoadIdentity();      
         
         gl.glOrtho(-1.5,1.5,-1.5,1.5,1,8);       
    }

	@Override
	public void keyPressed(KeyEvent e) {
		// TODO Auto-generated method stub
		switch (e.getKeyCode()) {
		  
		 case KeyEvent.VK_SPACE:
		          faceNormals = !faceNormals;
				
				  break;
		
		 default:
			 break;
		 }
		System.out.println("face normals " + faceNormals);
		
	}

	@Override
	public void keyReleased(KeyEvent arg0) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void keyTyped(KeyEvent arg0) {
		// TODO Auto-generated method stub
		
	}  
    
   
   
}
